%define upstream_name    Coro
%define upstream_version 6.23

%define _requires_exceptions perl(Exporter::)\\|perl(Coro::Socket::)
#define _without_check 1

Name:       perl-%{upstream_name}
Version:    %perl_convert_version %upstream_version
Release:    %mkrel 2
Epoch:      2

Summary:    Coroutine process abstraction
License:    GPL+ or Artistic
Group:      Development/Perl
Url:        http://search.cpan.org/dist/%{upstream_name}
Source0:    http://search.cpan.org/CPAN/authors/id/M/ML/MLEHMANN/%{upstream_name}-%{upstream_version}.tar.gz

BuildRequires: perl(AnyEvent) >= 5.0.0
BuildRequires: perl(ExtUtils::MakeMaker)
BuildRequires: perl(Guard) >= 0.500.0
BuildRequires: perl(Scalar::Util)
BuildRequires: perl(Storable) >= 2.150.0
BuildRequires: perl(Time::HiRes)
BuildRequires: perl(common::sense)
BuildRequires: perl-AnyEvent >= 1:4.05
BuildRequires: perl-common-sense
BuildRequires: perl-devel
BuildRequires: perl-EV >= 2.0
BuildRequires: perl-Event
BuildRequires: perl-Guard
BuildRequires: perl-IO-AIO
%description
This module collection manages coroutines. Coroutines are similar to
threads but don't run in parallel.

%package AnyEvent
Summary:    Use Coro within an AnyEvent environment
Group:      Development/Perl

%description AnyEvent
This module integrates coroutines into any event loop supported by
AnyEvent, combining event-based programming with coroutine-based
programming in a natural way.

%package BDB
Summary:    Truly asynchronous bdb access
Group:      Development/Perl

%description BDB
This module implements a thin wrapper around the BDB module.

Each BDB request that could block and doesn't get passed a callback
will normally block all coroutines. after loading this module, this
will no longer be the case.

%package EV
Summary:    Use Coro within an EV environment
Group:      Development/Perl

%description EV
This module integrates coroutines into any event loop supported by EV,
combining event-based programming with coroutine-based programming in a
natural way.

%prep
%setup -q -n %{upstream_name}-%{upstream_version} 
# change shebang lines if needed
perl -pi -e 's{/opt/bin/perl}{/usr/bin/perl}' eg/* Coro/*
# remove failing test - http://rt.cpan.org/Ticket/Display.html?id=32475
rm EV/t/01_unblock.t

%build
echo -e  "n\nu\n" | %{__perl} Makefile.PL INSTALLDIRS=vendor
%make

%check
%{!?_without_check:make test}

%install
rm -rf $RPM_BUILD_ROOT
%makeinstall_std

%clean
rm -rf $RPM_BUILD_ROOT

%files
%doc COPYING Changes EV INSTALL META.json META.yml MYMETA.yml README eg
%dir %{perl_vendorarch}/Coro
%{perl_vendorarch}/Coro/AIO.pm
%{perl_vendorarch}/Coro/Channel.pm
%{perl_vendorarch}/Coro/CoroAPI.h
%{perl_vendorarch}/Coro/Debug.pm
%{perl_vendorarch}/Coro/Event.pm
%{perl_vendorarch}/Coro/Handle.pm
%{perl_vendorarch}/Coro/Intro.pod
%{perl_vendorarch}/Coro/LWP.pm
%{perl_vendorarch}/Coro/MakeMaker.pm
%{perl_vendorarch}/Coro/RWLock.pm
%{perl_vendorarch}/Coro/Select.pm
%{perl_vendorarch}/Coro/Semaphore.pm
%{perl_vendorarch}/Coro/SemaphoreSet.pm
%{perl_vendorarch}/Coro/Signal.pm
%{perl_vendorarch}/Coro/Socket.pm
%{perl_vendorarch}/Coro/Specific.pm
%{perl_vendorarch}/Coro/State.pm
%{perl_vendorarch}/Coro/Storable.pm
%{perl_vendorarch}/Coro/Timer.pm
%{perl_vendorarch}/Coro/Util.pm
%{perl_vendorarch}/Coro/jit*
%{perl_vendorarch}/Coro.pm
%{perl_vendorarch}/auto
%_mandir/man3/Coro.3pm*
%_mandir/man3/Coro::AIO.3pm*
%_mandir/man3/Coro::Channel.3pm*
%_mandir/man3/Coro::Debug.3pm*
%_mandir/man3/Coro::Event.3pm*
%_mandir/man3/Coro::Handle.3pm*
%_mandir/man3/Coro::Intro.3pm*
%_mandir/man3/Coro::LWP.3pm*
%_mandir/man3/Coro::MakeMaker.3pm*
%_mandir/man3/Coro::RWLock.3pm*
%_mandir/man3/Coro::Select.3pm*
%_mandir/man3/Coro::Semaphore.3pm*
%_mandir/man3/Coro::SemaphoreSet.3pm*
%_mandir/man3/Coro::Signal.3pm*
%_mandir/man3/Coro::Socket.3pm*
%_mandir/man3/Coro::Specific.3pm*
%_mandir/man3/Coro::State.3pm*
%_mandir/man3/Coro::Storable.3pm*
%_mandir/man3/Coro::Timer.3pm*
%_mandir/man3/Coro::Util.3pm*

%files BDB
%{perl_vendorarch}/Coro/BDB.pm
%{_mandir}/man3/Coro::BDB*

%files AnyEvent
%{perl_vendorarch}/Coro/AnyEvent.pm
%{_mandir}/man3/Coro::AnyEvent*

%files EV
%{perl_vendorarch}/Coro/EV.pm
%{_mandir}/man3/Coro::EV*

%changelog

* Sun Jan 13 2013 umeabot <umeabot> 2:6.230.0-2.mga3
+ Revision: 364825
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Tue Jan 08 2013 jquelin <jquelin> 2:6.230.0-1.mga3
+ Revision: 341970
- update to 6.23

* Mon Oct 15 2012 jquelin <jquelin> 2:6.100.0-1.mga3
+ Revision: 306069
- update to 6.10

* Fri Aug 24 2012 pterjan <pterjan> 2:6.80.0-2.mga3
+ Revision: 283466
- Rebuild for new perl

* Tue Jun 05 2012 jquelin <jquelin> 2:6.80.0-1.mga3
+ Revision: 254725
- update to 6.08

* Wed May 30 2012 jquelin <jquelin> 2:6.70.0-2.mga3
+ Revision: 250386
- rebuild for perl 5.16

* Fri Nov 11 2011 kharec <kharec> 2:6.70.0-1.mga2
+ Revision: 166824
- update to 6.07

  + jquelin <jquelin>
    - update to 6.06
    - update to 6.02

* Fri Jul 08 2011 jquelin <jquelin> 2:6.10.0-1.mga2
+ Revision: 120366
- update to 6.01

* Thu Jun 30 2011 jquelin <jquelin> 2:6.0.0-2.mga2
+ Revision: 116723
- rebuild
- remove erroneous shebangs

* Thu Jun 30 2011 jquelin <jquelin> 2:6.0.0-1.mga2
+ Revision: 116473
- update to 6.0

* Fri Feb 25 2011 jquelin <jquelin> 2:5.372.0-1.mga2
+ Revision: 59636
- update to 5.372

* Tue Feb 22 2011 jquelin <jquelin> 2:5.371.0-1.mga1
+ Revision: 56509
- update to 5.371

* Mon Jan 24 2011 jquelin <jquelin> 2:5.250.0-1.mga1
+ Revision: 37015
- adding missing buildrequires:
- remove blocking EV test
- shipping perl-Coro-EV
- mageia rebuild
- remove files not found
- mageia rebuild
- imported package perl-Coro

